#ifndef _TYPES_H_
#define _TYPES_H_

typedef signed char s8;
typedef unsigned char u8;

typedef signed int s16;
typedef unsigned int u16;

typedef signed long int s32;
typedef unsigned long int u32;

typedef unsigned char BYTE;		/* 8-bit */
typedef unsigned int WORD;			/* 16-bit */
typedef unsigned long DWORD;		/* 32-bit */
typedef int INT;
typedef unsigned int UINT;
typedef short SHORT;
typedef unsigned short USHORT;

typedef int HWND;

typedef enum _BOOL {false = 0, true} bool;

#ifndef ON
#define ON (1)
#endif
#ifndef OFF
#define OFF (0)
#endif

typedef unsigned long zone_t;
typedef unsigned long bit_t;
typedef int	atomic_t;

#ifndef __ssize_t_defined
#define __ssize_t_defined
typedef short int ssize_t;
//typedef long ssize_t;
#endif

#ifndef __dev_t_defined
#define __dev_t_defined
typedef unsigned short dev_t;					/* eszkzszm */
#endif

#ifndef __ino_t_defined
#define __ino_t_defined
typedef unsigned short ino_t;		/* inode sorszm */
#endif

#ifndef __mode_t_defined
#define __mode_t_defined
typedef unsigned short mode_t;	/* file tpusa + jogok */
#endif

#ifndef __nlink_t_defined
#define __nlink_t_defined
typedef short nlink_t;
#endif

#ifndef __off_t_defined
#define __off_t_defined
typedef long off_t;				/* file-on belli offset */
#endif

#ifndef __time_t_defined
#define __time_t_defined
typedef long time_t;
#endif

#ifndef __uid_t_defined
#define __uid_t_defined
typedef unsigned short uid_t;
#endif

#ifndef __gid_t_defined
#define __gid_t_defined
typedef unsigned short gid_t;
#endif

#define BITS_PER_LONG (32)

#define BIT(k) (1U << (k))
#define BITUL(k) (1UL << (k))

/*#ifndef TRUE
#define TRUE (1)
#endif
#ifndef FALSE
#define FALSE (0)
#endif*/

/* ha ezt egy bit tpus vltozba teszem, akkor az LSB, teht 1 kerl bele */
#define INPUT (0xFF)
#define OUTPUT (0)
#define LOW (0)
#define HIGH (1)

#define MIN(a,b) (((a)<(b))?(a):(b))
#define MAX(a,b) (((a)>(b))?(a):(b))

typedef union {
	u16 Val;
	u8 v[2];
} U16_VAL;

typedef union {
	s16 Val;
	u8 v[2];
} S16_VAL;
	
typedef union {
	u32 Val;
	u8 v[4];
} U32_VAL;

typedef union {
	s32 Val;
	u8 v[4];
} S32_VAL;

#endif
